﻿Imports System.ComponentModel

Public Class Form1

    Private bmpout As Bitmap = Nothing
    Private facedetection As FaceDetection

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        BtLoadImage.Enabled = False
        facedetection = New FaceDetection
        If facedetection.GetIsFaceDetectorInitialized Then
            Dim intCount As Integer = facedetection.GetSupportedBitmapPixelFormatCount
            If intCount > 0 Then
                For intIndex As Integer = 0 To intCount - 1
                    CbPixelformats.Items.Add(facedetection.GetSupportedBitmapPixelFormatByIndex(intIndex).ToString)
                Next
                CbPixelformats.SelectedIndex = 0
                BtLoadImage.Enabled = True
            End If
        End If
    End Sub

    Private Sub Form1_Closing(sender As Object, e As CancelEventArgs) Handles Me.Closing
        If bmpout IsNot Nothing Then bmpout.Dispose()
        facedetection.Dispose()
    End Sub

    Private Sub BtLoadImage_Click(sender As Object, e As EventArgs) Handles BtLoadImage.Click
        Dim strFileName As String = String.Empty
        Using OFD As New OpenFileDialog
            With OFD
                .Title = "Open Image File"
                .Filter = "BMP Files (*.bmp)|*.bmp|" &
                          "JPG Files (*.jpg)|*.jpg|" &
                          "PNG Files (*.png)|*.png|" &
                          "GIF Files (*.gif)|*.gif"
                .FilterIndex = 2
                .ShowDialog()
                strFileName = .FileName
            End With
        End Using
        If Not String.IsNullOrEmpty(strFileName) Then
            If bmpout IsNot Nothing Then bmpout.Dispose()
            Using img As Image = Bitmap.FromFile(strFileName)
                bmpout = New Bitmap(img)
            End Using
            PBFacedetection.Image = New Bitmap(bmpout)
        End If
    End Sub

    Private Sub BtFaceDetection_Click(sender As Object, e As EventArgs) Handles BtFaceDetection.Click
        If PBFacedetection.Image IsNot Nothing Then
            PBFacedetection.Image.Dispose()
            PBFacedetection.Image = New Bitmap(bmpout)
            If facedetection.GetFaceDetectionResultsFromBitmap(CType(PBFacedetection.Image, Bitmap),
                                                               facedetection.GetSupportedBitmapPixelFormatByIndex(CbPixelformats.SelectedIndex)) Then
                Dim intCount As Integer = facedetection.GetDetectedFacesCount
                If intCount > 0 Then
                    Using gra As Graphics = Graphics.FromImage(PBFacedetection.Image)
                        Using pen As New Pen(Brushes.Red, 2)
                            'For intIndex As Integer = 0 To intCount - 1
                            '    gra.DrawRectangle(pen, facedetection.GetDetectedFaceBoundByIndex(intIndex))
                            'Next

                            gra.DrawRectangles(pen, facedetection.GetDetectedFacesBounds.ToArray)
                        End Using
                    End Using
                    PBFacedetection.Invalidate()
                End If
            End If
        End If
    End Sub
End Class
